<?php
/**
 * Omega Food Delivery functions and definitions
 * @package Omega Food Delivery
 */

if ( ! function_exists( 'omega_food_delivery_after_theme_support' ) ) :

	function omega_food_delivery_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'omega_food_delivery_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

        require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';
        require get_template_directory() . '/inc/metabox.php';


        if (! defined( 'OMEGA_FOOD_DELIVERY_DOCS_PRO' ) ){
        define('OMEGA_FOOD_DELIVERY_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-omega-food-delivery/','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_BUY_NOW' ) ){
        define('OMEGA_FOOD_DELIVERY_BUY_NOW',__('https://www.omegathemes.com/products/online-food-delivery-wordpress-theme','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_SUPPORT_FREE' ) ){
        define('OMEGA_FOOD_DELIVERY_SUPPORT_FREE',__('https://wordpress.org/support/theme/omega-food-delivery/','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_REVIEW_FREE' ) ){
        define('OMEGA_FOOD_DELIVERY_REVIEW_FREE',__('https://wordpress.org/support/theme/omega-food-delivery/reviews/#new-post/','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_DEMO_PRO' ) ){
        define('OMEGA_FOOD_DELIVERY_DEMO_PRO',__('https://layout.omegathemes.com/omega-food-delivery/','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_LITE_DOCS_PRO' ) ){
        define('OMEGA_FOOD_DELIVERY_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-omega-food-delivery/','omega-food-delivery'));
        }
        if (! defined( 'OMEGA_FOOD_DELIVERY_BUNDLE_BUTTON' ) ){
            define('OMEGA_FOOD_DELIVERY_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','omega-food-delivery'));
        }

	}

endif;

add_action( 'after_setup_theme', 'omega_food_delivery_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function omega_food_delivery_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $omega_food_delivery_theme_version = wp_get_theme()->get( 'Version' );
	$omega_food_delivery_fonts_url = omega_food_delivery_fonts_url();
    if( $omega_food_delivery_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'omega-food-delivery-google-fonts',
			omega_food_delivery_wptt_get_webfont_url( $omega_food_delivery_fonts_url ),
			array(),
			$omega_food_delivery_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'omega-food-delivery-style', get_stylesheet_uri(), array(), $omega_food_delivery_theme_version );

	wp_enqueue_style( 'omega-food-delivery-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'omega-food-delivery-style',$omega_food_delivery_custom_css );

	$omega_food_delivery_css = '';

	if ( get_header_image() ) :

		$omega_food_delivery_css .=  '
			section#center-header{
				background-image: url('.esc_url(get_header_image()).');
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'omega-food-delivery-style', $omega_food_delivery_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'omega-food-delivery-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$posts_per_page = absint( get_option('posts_per_page') );
        $c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $posts_args = array(
            'posts_per_page'        => $posts_per_page,
            'paged'                 => $c_paged,
        );
        $posts_qry = new WP_Query( $posts_args );
        $max = $posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $omega_food_delivery_default = omega_food_delivery_get_default_theme_options();
    $omega_food_delivery_pagination_layout = get_theme_mod( 'omega_food_delivery_pagination_layout',$omega_food_delivery_default['omega_food_delivery_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'omega_food_delivery_register_styles',200 );

function omega_food_delivery_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('omega-food-delivery-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'omega_food_delivery_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function omega_food_delivery_menus() {

	$omega_food_delivery_locations = array(
		'omega-food-delivery-primary-menu'  => esc_html__( 'Primary Menu', 'omega-food-delivery' ),
	);

	register_nav_menus( $omega_food_delivery_locations );
}

add_action( 'init', 'omega_food_delivery_menus' );

add_filter('loop_shop_columns', 'omega_food_delivery_loop_columns');
if (!function_exists('omega_food_delivery_loop_columns')) {
	function omega_food_delivery_loop_columns() {
		$omega_food_delivery_columns = get_theme_mod( 'omega_food_delivery_per_columns', 3 );
		return $omega_food_delivery_columns;
	}
}

add_filter( 'loop_shop_per_page', 'omega_food_delivery_per_page', 20 );
function omega_food_delivery_per_page( $omega_food_delivery_cols ) {
  	$omega_food_delivery_cols = get_theme_mod( 'omega_food_delivery_product_per_page', 9 );
	return $omega_food_delivery_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'omega_food_delivery_products_args' );

function omega_food_delivery_products_args( $omega_food_delivery_args ) {

    $omega_food_delivery_args['posts_per_page'] = get_theme_mod( 'omega_food_delivery_custom_related_products_number', 6 );

    $omega_food_delivery_args['columns'] = get_theme_mod( 'omega_food_delivery_custom_related_products_number_per_row', 3 );

    return $omega_food_delivery_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function omega_food_delivery_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'omega_food_delivery_remove_customize_register', 11 );

function omega_food_delivery_radio_sanitize(  $omega_food_delivery_input, $omega_food_delivery_setting  ) {
	$omega_food_delivery_input = sanitize_key( $omega_food_delivery_input );
	$omega_food_delivery_choices = $omega_food_delivery_setting->manager->get_control( $omega_food_delivery_setting->id )->choices;
	return ( array_key_exists( $omega_food_delivery_input, $omega_food_delivery_choices ) ? $omega_food_delivery_input : $omega_food_delivery_setting->default );
}
require get_template_directory() . '/inc/general.php';

function omega_food_delivery_timeAgo($timestamp) {
    // If timestamp is already an integer, use it directly
    if (is_numeric($timestamp)) {
        $omega_food_delivery_timeAgo = (int) $timestamp;
    } else {
        $omega_food_delivery_timeAgo = strtotime($timestamp);
        
        // Ensure conversion was successful
        if (!$omega_food_delivery_timeAgo) {
            return "Invalid date format";
        }
    }

    $currentTime = time();
    $timeDifference = $currentTime - $omega_food_delivery_timeAgo;

    if ($timeDifference < 0) {
        return "Future date";
    }

    $seconds = $timeDifference;
    $minutes = round($seconds / 60);
    $hours = round($seconds / 3600);
    $days = round($seconds / 86400);
    $weeks = round($seconds / 604800);
    $months = round($seconds / 2629440);
    $years = round($seconds / 31553280);

    if ($seconds < 60) {
        return "just now";
    } elseif ($minutes < 60) {
        return "$minutes min" . ($minutes > 1 ? "s" : "") . " ago";
    } elseif ($hours < 24) {
        return "$hours hr" . ($hours > 1 ? "s" : "") . " ago";
    } elseif ($days < 7) {
        return "$days day" . ($days > 1 ? "s" : "") . " ago";
    } elseif ($weeks < 4) {
        return "$weeks week" . ($weeks > 1 ? "s" : "") . " ago";
    } elseif ($months < 12) {
        return "$months month" . ($months > 1 ? "s" : "") . " ago";
    } else {
        return "$years year" . ($years > 1 ? "s" : "") . " ago";
    }
}

// NOTICE FUNCTION

function omega_food_delivery_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'omega_food_delivery_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_omegafooddelivery-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Omega Food Delivery. Let’s Set Up Your Website!', 'omega-food-delivery') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'omega-food-delivery') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=omegafooddelivery-wizard' ) ); ?>"><?php esc_html_e('Get Started with Omega Food Delivery', 'omega-food-delivery'); ?></a>
					<a target="_blank" href="<?php echo esc_url( OMEGA_FOOD_DELIVERY_BUNDLE_BUTTON ); ?>" class="notice-bundle"><?php esc_html_e('Get All WP Themes', 'omega-food-delivery'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?omega_food_delivery_admin_notice=1"><?php esc_html_e( 'Dismiss', 'omega-food-delivery' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'omega_food_delivery_admin_notice' );

if ( ! function_exists( 'omega_food_delivery_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function omega_food_delivery_update_admin_notice() {
    if ( isset( $_GET['omega_food_delivery_admin_notice'] ) && $_GET['omega_food_delivery_admin_notice'] == '1' ) {
        update_option( 'omega_food_delivery_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'omega_food_delivery_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'omega_food_delivery_getstart_setup_options' );
function omega_food_delivery_getstart_setup_options() {
    update_option( 'omega_food_delivery_admin_notice', false );
}

function omega_food_delivery_sticky_sidebar_enabled() {
    $omega_food_delivery_sticky_sidebar = get_theme_mod('omega_food_delivery_sticky_sidebar', true);
    
    if ($omega_food_delivery_sticky_sidebar == false) {
        $omega_food_delivery_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('omega-food-delivery-style', $omega_food_delivery_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'omega_food_delivery_sticky_sidebar_enabled');